'From Squeak3.10alpha of 12 December 2006 [latest update: #7068] on 12 May 2007 at 3:57:17 pm'!
PackageInfo subclass: #MaBaseAdditionsPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-Info'!
Object subclass: #MaObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-abstractions'!
Object subclass: #MaOverrider
	instanceVariableNames: 'overriders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-domains'!

!MaOverrider commentStamp: '<historical>' prior: 0!
I provide a list of objects a chance to handle a message and answer a non-nil before allowing the overridee a chance.  Primarily, I am intended to provide chain-of-responsibility for preferences.  A global preferences object is shared by most, but need to be selectively overridden.!

Morph subclass: #MaProgressBarMorph
	instanceVariableNames: 'bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-widgets'!
MaObject subclass: #MaSingleton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-abstractions'!
MaSingleton class
	instanceVariableNames: 'current'!
MaObject subclass: #MaStat
	instanceVariableNames: 'last min max count sum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-domains'!
MaOverrider subclass: #MaSystemNavigationOverrider
	instanceVariableNames: ''
	classVariableNames: 'OriginalSystemNavigation'
	poolDictionaries: ''
	category: 'Ma base additions-domains'!
MaObject subclass: #MaTextMessage
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-domains'!

!MaTextMessage commentStamp: '<historical>' prior: 0!
This little tool helps you build non-wimpy message strings.!


!ProtoObject methodsFor: '*ma base additions' stamp: 'cmm 1/16/2005 14:03'!
maInstSize
	"Answer the number of named and indexed instance variables referenced by
	the receiver."

	^self class instSize + self basicSize
! !


!Object methodsFor: '*ma base additions' stamp: 'cmm 8/21/2004 15:53'!
maAbbreviatedString
	"This is intended to support two possible string representations for any object
	instead of just one.  The normal one and this abbreivated one.  The normal one provides type-information, the abbreviation provides the identifier.  An abbreviated
	provides a brevity that proves useful when looking at collections or
	other 'container' type objects.

	Suggested usage is to omit the objects type (e.g. class name) for printing abbreviated,
	but include it for standard printOn:"

	^ String streamContents: [ : stream | self maPrintAbbreviatedOn: stream ]! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 12/20/2004 23:53'!
maMarked: aString
	"This is a marker method used to indicate that we wish to come back and re-examine
	code in the future for possible improvement.  For now, try to keep improvements categorized
	via anEsAtom that we can Browse References to, if necessary.  The possibilities should be:

		'ugly'
		'performance'
		'bug'
		'dev'
		'vmSpecific'
		'releaseSpecific'
		'system override'
		'deprecated'
		'magic'
		'debug'
	A *comment* then should follow to provide more detail."

	
aString = 'delete' ifTrue: [ self halt: 'Oops..  looks like you still need this method.' ]! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 4/10/2005 18:00'!
maOriginalClass
	"Unfortunately, we don't have complete class-transparency with WriteBarrier.  #species isn't always the quite the thing needed.  In rare cases (browse my senders), my actual class is needed."

	^self class! !

!Object methodsFor: '*ma base additions' stamp: 'cm 12/29/2001 01:14'!
maPrintAbbreviatedOn: aStream
	"This is intended to support two possible string representations for any object
	instead of just one.  The normal one and this abbreivated one.  An abbreviated
	provides a brevity that proves useful when looking at collections or
	other 'container' type objects.

	Suggested usage is to omit the objects type (e.g. class name) for printing abbreviated,
	but include it for standard printOn:"
! !

!Object methodsFor: '*ma base additions'!
maPrintAttribute: aSymbol on: aStream

	(self class allInstVarNames includes: aSymbol asString)
		ifTrue:
			[ self
				maPrintInstVar: aSymbol
				on: aStream ]
		ifFalse:
			[ self
				maPrintSelector: aSymbol
				on: aStream ]
! !

!Object methodsFor: '*ma base additions'!
maPrintAttributes: arrayOfSymbols on: aStream

	arrayOfSymbols do:
		[ :each |
		self
			maPrintAttribute: each
			on: aStream ]
! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 23:26'!
maPrintInstVar: aSymbol on: aStream

	| value |

	aStream
		cr;
		tab;
		nextPutAll: aSymbol;
		nextPutAll: ' = '.
	value := self instVarNamed: aSymbol asString.
	(value isCollection and: [ value isString not ])
		ifTrue:
			[ value do:
				[ :each |
				aStream
					maPrint: each;
					space ] ]
		ifFalse:
			[ aStream maPrint: value ]
! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 5/11/2003 22:16'!
maPrintSelector: aSymbol on: aStream

	| value |

	aStream
		cr;
		tab;
		nextPutAll: aSymbol;
		nextPutAll: ' : '.
	value :=
		[ self perform: aSymbol ]
			on: Error
			do: [ :exc | exc return: '**invalid**' ].
	(value isCollection and: [ value isString not ])
		ifTrue:
			[ value do:
				[ :each |
				aStream
					maPrint: each;
					space ] ]
		ifFalse:
			[ aStream maPrint: value ]! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:46'!
maShallowCopy

	^self shallowCopy! !


!Behavior methodsFor: '*ma base additions' stamp: 'cmm 12/2/2004 15:07'!
maAllInstVarNamesDo: aBlock

	superclass ifNotNil: [ superclass maAllInstVarNamesDo: aBlock ].
	self instVarNames do: aBlock! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 12/16/2004 01:26'!
maAllSelectorsDo: aBlock

	self selectorsDo: aBlock.
	superclass ifNotNil: [ superclass maAllSelectorsDo: aBlock ]! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 11/19/2003 22:48'!
maFirstCommentAt: selector
	"A much more-convenient method than firstCommentAt:, which requires you to specify the exact class, a problem when the method is implemented in the superclass methodDict."

	^(self methodDict includesKey: selector)
		ifTrue: [ self firstCommentAt: selector ]
		ifFalse: [ self superclass maFirstCommentAt: selector ]! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 11/19/2003 22:53'!
maFirstCommentOrNilAt: selector
	"A much more-convenient method than firstCommentAt:, which requires you to specify the exact class, a problem when the method is implemented in the superclass methodDict."

	| string |
	^(string _ self maFirstCommentAt: selector) isEmpty
		ifTrue: [ nil ]
		ifFalse: [ string ]! !


!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 3/13/2005 17:37'!
bench
	"See how many times I can value in 5 seconds.  I'll answer a meaningful description."

	| startTime endTime count |
	count _ 0.
	endTime _ Time millisecondClockValue + 5000.
	startTime _ Time millisecondClockValue.
	[ Time millisecondClockValue > endTime ] whileFalse: [ self value.  count _ count + 1 ].
	endTime _ Time millisecondClockValue.
	^count = 1
		ifTrue: [ ((endTime - startTime) // 1000) printString, ' seconds.' ]
		ifFalse:
			[ ((count * 1000) / (endTime - startTime)) asFloat printString, ' per second.' ]! !

!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 12/5/2002 21:43'!
maBench
	"See how many times I can value in 5 seconds.  I'll answer a meaningful description."

	| startTime endTime count |
	count _ 0.
	endTime _ Time millisecondClockValue + 5000.
	startTime _ Time millisecondClockValue.
	[ Time millisecondClockValue > endTime ] whileFalse: [ self value.  count _ count + 1 ].
	endTime _ Time millisecondClockValue.
	^count = 1
		ifTrue: [ ((endTime - startTime) // 1000) printString, ' seconds.' ]
		ifFalse:
			[ ((count * 1000) / (endTime - startTime)) asFloat printString, ' per second.' ]! !

!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 3/23/2003 22:40'!
maOn: exc1 do: block1 on: exc2 do: block2

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		on: exc2
		do: block2! !

!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 3/23/2003 22:43'!
maOn: exc1 do: block1 on: exc2 do: block2 on: exc3 do: block3

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		maOn: exc2
		do: block2

		on: exc3
		do: block3! !


!Character methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:44'!
maShallowCopy
	"Characters are unique."

	^self
! !


!Collection methodsFor: '*ma base additions' stamp: 'cmm 7/9/2002 22:59'!
maConsistsOf: aCollection
	"Answer whether the receiver and aCollection reference all equal
	objects, including the same number of references to those objects.  Order
	is not a factor."

	^self size = aCollection size and: [ self maIncludesAll: aCollection ]
! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 9/27/2003 19:46'!
maDeepCopy
	"Squeak, in my opinion, does not make deepCopies of Collections consistent with other objects."

	^self collect: [ : each | each copy ]! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 1/16/2002 16:48'!
maDetect: aBlock ifFound: foundBlock ifNone: exceptionBlock 
	"foundBlock takes one argument, the found object."

	self 
		do: [ :element | (aBlock value: element) ifTrue: [ ^foundBlock value: element ] ].
	^exceptionBlock value
! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 7/24/2004 01:05'!
maDo: aBlock while: conditionBlock

	conditionBlock value ifFalse: [ ^ self ].
	self do:
		[ : each |
		aBlock value: each.
		conditionBlock value ifFalse: [ ^ self ] ]! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 21:32'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	self size > 20
		ifTrue:
			[ ^self asBag maIncludesAll: aCollection ].
	otherColl :=
		aCollection size > 20
			ifTrue: [ aCollection asBag ]
			ifFalse: [ aCollection ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true! !

!Collection methodsFor: '*ma base additions'!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection.  In SequencableCollections, the order must be
	the same as well."

	^self maConsistsOf: anotherCollection
! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 20:29'!
maRemoveAll
	"Efficiently removes all elements from the receiver."

	self init: self size! !

!Collection methodsFor: '*ma base additions'!
maRemoveAll: aCollection forEachAbsent: aBlock

	^aCollection do:
		[ :element |
		self
			remove: element
			ifAbsent: [ aBlock value: element ] ]
! !


!Bag methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 21:33'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	otherColl :=
		aCollection size > 20
			ifTrue: [ aCollection asBag ]
			ifFalse: [ aCollection ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true! !

!Bag methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 20:20'!
maRemoveAll
	"Efficiently removes all elements in the receiver."

	self setContents: (self class contentsClass new: contents size)! !

!Bag methodsFor: '*ma base additions' stamp: 'cmm 3/28/2005 21:57'!
printOn: aStream

	aStream
		nextPutAll: (self class name first isVowel ifTrue: [ 'an ' ] "$NON-NLS$" ifFalse: [ 'a ' ]). "$NON-NLS$"
	self species printOn: aStream.
	contents keysAndValuesDo:
		[ :eachKey :eachValue |
		aStream
			cr; tab;
			nextPut: $(;
			maPrint: eachValue;
			nextPutAll: ') ';
			maPrint: eachKey ]
! !


!Delay methodsFor: '*ma base additions' stamp: 'cmm 9/1/2004 22:25'!
maReset
	"If I am already waiting, start my wait back at the beginning.  If I'm not yet waiting, no effect."
	resumptionTime _ Time millisecondClockValue + delayDuration! !


!FileDirectory methodsFor: '*ma base additions' stamp: 'cmm 6/8/2005 16:03'!
maCopyFileNamed: sourceFilename toDirectory: aFileDirectory

	| sourceStream |
	sourceStream _ (self readOnlyFileNamed: sourceFilename) binary.
	aFileDirectory
		putFile: sourceStream
		named: (aFileDirectory localNameFor: sourceFilename)! !

!FileDirectory methodsFor: '*ma base additions' stamp: 'cmm 4/8/2002 20:52'!
maEntriesMatching: pat
	"FileDirectory default fileNamesMatching: '*'"

	^ self entries select: [ :each | pat match: each name ]
! !


!MaBaseAdditionsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2003 00:05'!
prerequisitePackages

	^#('Ma exception handling')! !

!MaBaseAdditionsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/9/2005 19:27'!
readmeText

	^'I consist of just over 50 method extensions that all begin with the letters "ma".  These are methods that I needed for one or more of the other "Ma" frameworks, but felt it was general enough to be useful to other programs.'! !


!MaObject methodsFor: 'copying' stamp: 'cmm 12/19/2002 23:23'!
copyAttributes: anArray from: sourceObject

	anArray do:
		[ :each |
		self
			instVarNamed: each asString
			put: (sourceObject instVarNamed: each) copy ]! !

!MaObject methodsFor: 'private'!
initialize

	"Default, do nothing."
! !

!MaObject methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:13'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	self maPrintAbbreviatedOn: aStream
! !


!MaOverrider methodsFor: 'building' stamp: 'cmm 3/3/2004 22:45'!
addOverrider: anObject

	overriders add: anObject! !

!MaOverrider methodsFor: 'building' stamp: 'cmm 3/3/2004 22:45'!
removeOverrider: anObject

	overriders remove: anObject! !

!MaOverrider methodsFor: 'private' stamp: 'cmm 3/3/2004 22:53'!
doesNotUnderstand: aMessage

	overriders do:
		[ : each |
		(each respondsTo: aMessage selector)
			ifTrue: 
				[ | answer |
				answer _ aMessage sentTo: each.
				answer ifNotNil: [ ^ answer ] ] ].
	^ aMessage sentTo: self overridee! !

!MaOverrider methodsFor: 'private' stamp: 'cmm 7/1/2004 10:50'!
initialize
	super initialize.
	overriders := OrderedCollection new: 1! !

!MaOverrider methodsFor: 'subclass responsibility' stamp: 'cmm 3/3/2004 22:54'!
overridee

	self subclassResponsibility! !


!MaProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'cmm 11/12/2003 22:59'!
initialize

	super initialize.
	self
		extent: 100@12;
		color: Color gray;
		layoutPolicy: TableLayout new;
		position: 100@100.
	bar _ RectangleMorph new
		color: Color green;
		extent: 0@self height;
		layoutInset: 0;
		position: 0@0;
		setBorderStyle: #complexRaised;
		vResizing: #spaceFill;
		yourself.
	self percent: 0.0.
	self addMorph: bar! !

!MaProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/6/2003 00:23'!
percent: aFloat "between 0.0 and 1.0"

	| secureFloat |
	secureFloat _ aFloat > 1.0 ifTrue: [ 1.0 ] ifFalse: [ aFloat < 0.0 ifTrue: [ 0.0 ] ifFalse: [ aFloat ] ].
	bar width: self width*secureFloat! !

!MaProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'cmm 7/19/2004 23:52'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	bar _ bar veryDeepCopyWith: aDeepCopier! !


!MaSingleton class methodsFor: 'accessing' stamp: 'cmm 1/10/2005 21:55'!
current

	^ current ifNil: [ current _ self new ]! !

!MaSingleton class methodsFor: 'actions' stamp: 'cmm 1/10/2005 21:54'!
initialize

	super initialize.
	self reset! !

!MaSingleton class methodsFor: 'actions' stamp: 'cmm 1/10/2005 21:56'!
reset

	current _ nil! !


!MaStat methodsFor: 'accessing' stamp: 'cmm 11/16/2004 21:54'!
addValue: aMagnitude
	"This is named addValue: instead of add: to be easier to find senders."
	self last: aMagnitude.
	count _ count + 1.
	min _ min ifNil: [ aMagnitude ] ifNotNil: [ min min: aMagnitude ].
	max _ max ifNil: [ aMagnitude ] ifNotNil: [ max max: aMagnitude ].
	sum _ sum ifNil: [ aMagnitude ] ifNotNil: [ sum + aMagnitude ]! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 2/4/2003 11:53'!
count

	^count! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 11/16/2004 21:49'!
last

	^ last! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 11/16/2004 21:50'!
last: aMagnitude

	last _ aMagnitude! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 2/4/2003 11:53'!
max

	^max! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 11/16/2004 21:52'!
mean

	^ (sum / count) asFloat! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 2/4/2003 11:53'!
min

	^min! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 11/16/2004 21:51'!
sum

	^ sum! !

!MaStat methodsFor: 'private' stamp: 'cmm 7/1/2004 10:51'!
initialize
	super initialize.
	count := 0! !

!MaStat methodsFor: 'printing' stamp: 'cmm 11/16/2004 21:52'!
maPrintAbbreviatedOn: aStream

	self
		maPrintAttributes: #(min max sum count mean)
		on: aStream! !


!MaStat class methodsFor: 'as yet unclassified' stamp: 'cmm 11/16/2004 10:51'!
example

	| stat |
	stat _ self new.
	#(1 2 5 8 9 15) do: [ :each | stat addValue: each ].
	stat! !


!MaSystemNavigationOverrider methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2004 22:56'!
overridee

	^ OriginalSystemNavigation! !


!MaSystemNavigationOverrider class methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2004 22:56'!
initialize

	OriginalSystemNavigation _ SystemNavigation default! !

!MaSystemNavigationOverrider class methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2004 22:57'!
unload

	SystemNavigation maDefault: OriginalSystemNavigation ! !


!MaTextMessage methodsFor: 'building' stamp: 'cmm 3/6/2002 22:47'!
append: aString

	self appendString: aString
! !

!MaTextMessage methodsFor: 'building'!
appendAndedList: aCollection

	self
		appendList: (
			aCollection
				collect: [ :each | each isString ifTrue: [ each ] ifFalse: [ each printString ] ])
		with: ' and '
! !

!MaTextMessage methodsFor: 'building'!
appendCount: aNumber of: aString
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	self
		append: aNumber;
		space.
	self
		appendProperlyPluralized: aString
		for: aNumber
! !

!MaTextMessage methodsFor: 'building' stamp: 'cmm 11/25/2003 00:19'!
appendProperlyPluralized: aString for: aNumber
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	self append: aString.
	aString last asLowercase = $s
		ifTrue: [ stream nextPut: $' ]
		ifFalse: [ stream nextPut: $s ]! !

!MaTextMessage methodsFor: 'building'!
space

	self append: $ 
! !

!MaTextMessage methodsFor: 'private initializing'!
appendList: aCollection with: aString

	| index |

	aCollection isEmpty ifTrue: [ ^nil ].
	index := 1.
	aCollection do:
		[ :each |
		self append: each.
		aCollection size > 1
			ifTrue:
				[ index < (aCollection size - 1)
					ifTrue:
						[ self append: ', ' ]
					ifFalse:
						[ index = (aCollection size - 1) ifTrue: [ self append: aString ] ] ].
		index := index + 1 ]
! !

!MaTextMessage methodsFor: 'private initializing' stamp: 'cmm 11/25/2003 00:16'!
initialize

	super initialize.
	stream _ String new writeStream! !

!MaTextMessage methodsFor: 'private building' stamp: 'cmm 11/25/2003 00:17'!
appendString: anObject

	anObject isString 
		ifTrue: [ stream nextPutAll: anObject ] 
		ifFalse: [ anObject printOn: stream ]! !

!MaTextMessage methodsFor: 'accessing' stamp: 'cmm 11/25/2003 00:22'!
messageText

	stream last = $. ifFalse: [ stream nextPut: $. ].
	^stream contents
! !

!MaTextMessage methodsFor: 'private accessing' stamp: 'cmm 11/25/2003 00:16'!
string

	^stream contents! !


!Message methodsFor: '*ma base additions' stamp: 'cmm 7/10/2003 23:12'!
maArguments: anArray

	args _ anArray! !


!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2004 10:39'!
maActualMethod

	| class |
	^(class _ self actualClass)
		ifNil: [ nil ]
		ifNotNil:
			[ (class canUnderstand: self methodSymbol)
				ifTrue: [ class >> self methodSymbol ]
				ifFalse: [ nil ] ]! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 8/19/2003 23:53'!
maCategory
	^ self actualClass organization categoryOfElement: methodSymbol! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2004 11:07'!
maSourceCode
	^ self maActualMethod
		ifNotNilDo: [ : method | self actualClass sourceCodeAt: methodSymbol ]! !


!Number methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:40'!
maPrintAbbreviatedOn: aStream

	self printOn: aStream
! !


!Integer methodsFor: '*ma base additions' stamp: 'cmm 4/29/2005 17:12'!
maBitSet: index

	"Return the receiver with the bit at index set."

	^self bitOr: (1 bitShift: index - 1)! !

!Integer methodsFor: '*ma base additions' stamp: 'cmm 2/15/2002 00:24'!
maIsBitSet: bitPosition

	^self allMask: (2 raisedTo: bitPosition-1)
! !


!ReadStream methodsFor: '*ma base additions' stamp: 'cmm 7/1/2003 22:12'!
maUpToIncluding: anObject

	| start end |
	start _ position+1.
	end _ collection indexOf: anObject startingAt: start ifAbsent: [ 0 ].

	"not present--return rest of the collection"	
	end = 0 ifTrue: [ ^self upToEnd ].

	"skip to the end and return the data passed over"
	position _ end.
	^collection copyFrom: start to: end! !


!Rectangle methodsFor: '*ma base additions' stamp: 'cmm 8/25/2003 23:42'!
maPointAtRandom

	^(self topLeft x + self width atRandom) @ (self topLeft y + self height atRandom)! !


!SecureHashAlgorithm methodsFor: '*ma base additions' stamp: 'cmm 6/9/2005 11:55'!
maHashMessage: aStringOrByteArray from: startPos to: stopPos
	"Hash the given message using the Secure Hash Algorithm."

	^ self
		maHashStream: 
			((ReadStream on: aStringOrByteArray asByteArray)
				position: startPos-1 ;
				yourself)
		to: stopPos! !

!SecureHashAlgorithm methodsFor: '*ma base additions' stamp: 'cmm 6/9/2005 11:59'!
maHashStream: aPositionableStream to: endPosition
	"Hash the contents of the given stream from the current position to endPosition using the Secure Hash Algorithm. The SHA algorithm is defined in FIPS PUB 180-1. It is also described on p. 442 of 'Applied Cryptography: Protocols, Algorithms, and Source Code in C' by Bruce Scheier, Wiley, 1996."

	| currentPosition buf bitLength |
	self initializeTotals.
	aPositionableStream atEnd ifTrue: [self error: 'empty stream'].
	endPosition > aPositionableStream size ifTrue: [ self error: 'invalid endPosition' ].
	[ currentPosition _ aPositionableStream position.
	currentPosition < endPosition ]
		whileTrue:
			[ buf _ aPositionableStream next: (64 min: endPosition-currentPosition).
			(currentPosition < endPosition
			and: [buf size = 64])
				ifTrue: [ self processBuffer: buf ]
				ifFalse: 
					[ bitLength _ (endPosition - currentPosition) * 8.
					self processFinalBuffer: buf bitLength: bitLength ] ].
	^ self finalHash! !


!SequenceableCollection methodsFor: '*ma base additions' stamp: 'cmm 12/30/2003 23:43'!
maAfter: anObject ifError: aBlock
	"A more-flexible substitute for after:ifAbsent: which, if anObject is the last object in me, errors out instead of calling the ifAbsent block.  This version does, making your code cleaner."

	self last == anObject ifTrue: [ ^ aBlock value ].
	^self
		after: anObject
		ifAbsent: aBlock! !

!SequenceableCollection methodsFor: '*ma base additions' stamp: 'cmm 12/30/2003 23:44'!
maBefore: anObject ifError: aBlock
	"A more-flexible substitute for before:ifAbsent: which, if anObject is the last object in me, errors out instead of calling the ifAbsent block.  This version does, making your code cleaner."

	self first == anObject ifTrue: [ ^ aBlock value ].
	^self
		before: anObject
		ifAbsent: aBlock! !

!SequenceableCollection methodsFor: '*ma base additions' stamp: 'cmm 5/18/2004 12:01'!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection and in the same order."

	self == anotherCollection ifTrue: [ ^ true ].
	self size = anotherCollection size ifFalse: [ ^false ].
	self
		with: anotherCollection
		do: [ :eachInSelf :eachInOther | eachInSelf = eachInOther ifFalse: [ ^false ] ].
	^true
! !

!SequenceableCollection methodsFor: '*ma base additions' stamp: 'brp 4/7/2005 09:14'!
maMerge: aCollection sortBlock: sortBlock collectBlock: collectBlock
	"Merge the receiver with aCollection"

	| answer first last a b swap |
	self isEmpty ifTrue: [^aCollection asOrderedCollection].
	aCollection isEmpty ifTrue: [^self asOrderedCollection].
	answer := OrderedCollection new: self size + aCollection size.
	first := self readStream.
	last := aCollection readStream.
	a := first next.
	b := last next.
	[true] whileTrue: [
		[(sortBlock value: a value: b) or: [(sortBlock value: b value: a) not]]
			whileTrue: [
				answer addLast: (collectBlock value: a).
				first atEnd ifTrue: [
					answer addLast: (collectBlock value: b).
					last upToEnd do: [ :l | answer addLast: (collectBlock value: l)].
					^ answer ].
				a := first next ].
		swap := first.
		first := last.
		last := swap.
		swap := a.
		a := b.
		b := swap ]
! !


!Array methodsFor: '*ma base additions' stamp: 'cmm 12/1/2004 23:10'!
maInstSize
	"Override from Object because this is considerably faster."
	^ self size! !


!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 12/1/2004 23:02'!
maInstSize
	"Override from Object because this is many times faster."
	^ self size! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/18/2005 10:12'!
maUint: bits at: anInteger

	| answer bytes |
	bits == 64 ifTrue: [ ^ self maUnsigned64At: anInteger + 1 ].
	bits == 56 ifTrue: [ ^ self maUnsigned56At: anInteger + 1 ].
	bits == 48 ifTrue: [ ^ self maUnsigned48At: anInteger + 1 ].
	bits == 40 ifTrue: [ ^ self maUnsigned40At: anInteger + 1 ].
	bits == 32
		ifTrue:
			[ ^self
				unsignedLongAt: anInteger + 1
				bigEndian: false ].
	bits == 16
		ifTrue:
			[ ^self
				unsignedShortAt: anInteger + 1
				bigEndian: false ].
	bits == 8 
		ifTrue:
			[ ^self byteAt: anInteger + 1 ].
	bytes _ bits // 8.
	answer _ LargePositiveInteger new: bytes.
	1 to: bytes do:
		[ :digitPosition |
		answer
			digitAt: digitPosition
			put: (self at: digitPosition + anInteger) ].
	^answer normalize! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/18/2005 10:30'!
maUint: bits at: position put: anInteger

	position + 1
		to: position + (bits // 8)
		do:
			[ :pos |
			self
				at: pos
				put: (anInteger digitAt: pos-position) ].
	^anInteger! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/18/2005 10:09'!
maUnsigned40At: index
	"Return a 32bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 w |

	w _ self at: index.
	b3 _ self at: index+1.
	b2 _ self at: index+2.
	b1 _ self at: index+3.
	b0 _ self at: index+4.

	"Minimize LargeInteger arithmetic"
	b3 = 0 ifFalse:[w _ (b3 bitShift: 8) + w].
	b2 = 0 ifFalse:[w _ (b2 bitShift: 16) + w].
	b1 = 0 ifFalse:[w _ (b1 bitShift: 24) + w].
	b0 = 0 ifFalse:[w _ (b0 bitShift: 32) + w].

	^w! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/18/2005 10:04'!
maUnsigned48At: index
	"Return a 32bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 b4 w |

	w _ self at: index.
	b4 _ self at: index+1.
	b3 _ self at: index+2.
	b2 _ self at: index+3.
	b1 _ self at: index+4.
	b0 _ self at: index+5.

	"Minimize LargeInteger arithmetic"
	b4 = 0 ifFalse:[w _ (b4 bitShift: 8) + w].
	b3 = 0 ifFalse:[w _ (b3 bitShift: 16) + w].
	b2 = 0 ifFalse:[w _ (b2 bitShift: 24) + w].
	b1 = 0 ifFalse:[w _ (b1 bitShift: 32) + w].
	b0 = 0 ifFalse:[w _ (b0 bitShift: 40) + w].

	^w! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/18/2005 10:03'!
maUnsigned56At: index
	"Return a 32bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 b4 b5 w |

	w _ self at: index.
	b5 _ self at: index+1.
	b4 _ self at: index+2.
	b3 _ self at: index+3.
	b2 _ self at: index+4.
	b1 _ self at: index+5.
	b0 _ self at: index+6.

	"Minimize LargeInteger arithmetic"
	b5 = 0 ifFalse:[w _ (b5 bitShift: 8) + w].
	b4 = 0 ifFalse:[w _ (b4 bitShift: 16) + w].
	b3 = 0 ifFalse:[w _ (b3 bitShift: 24) + w].
	b2 = 0 ifFalse:[w _ (b2 bitShift: 32) + w].
	b1 = 0 ifFalse:[w _ (b1 bitShift: 40) + w].
	b0 = 0 ifFalse:[w _ (b0 bitShift: 48) + w].

	^w! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/18/2005 09:59'!
maUnsigned64At: index
	"Return a 32bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 b4 b5 b6 w |

	w _ self at: index.
	b6 _ self at: index+1.
	b5 _ self at: index+2.
	b4 _ self at: index+3.
	b3 _ self at: index+4.
	b2 _ self at: index+5.
	b1 _ self at: index+6.
	b0 _ self at: index+7.

	"Minimize LargeInteger arithmetic"
	b6 = 0 ifFalse:[w _ (b6 bitShift: 8) + w].
	b5 = 0 ifFalse:[w _ (b5 bitShift: 16) + w].
	b4 = 0 ifFalse:[w _ (b4 bitShift: 24) + w].
	b3 = 0 ifFalse:[w _ (b3 bitShift: 32) + w].
	b2 = 0 ifFalse:[w _ (b2 bitShift: 40) + w].
	b1 = 0 ifFalse:[w _ (b1 bitShift: 48) + w].
	b0 = 0 ifFalse:[w _ (b0 bitShift: 56) + w].

	^w! !


!CompiledMethod methodsFor: '*ma base additions' stamp: 'cmm 2/17/2002 16:16'!
maMethodClass

	^self who first
! !

!CompiledMethod methodsFor: '*ma base additions' stamp: 'cmm 7/3/2003 12:31'!
maSourceString

	^(self
		getSourceFor: self selector
		in: self maMethodClass) asString! !


!Interval methodsFor: '*ma base additions' stamp: 'cmm 6/4/2005 17:22'!
maEnvelopes: anInterval 
	"Return true if anInterval fits entirely inside the receiver."

	^ (anInterval first between: start and: stop)
	and: [ anInterval last between: start and: stop ]! !

!Interval methodsFor: '*ma base additions' stamp: 'cmm 6/4/2005 01:09'!
maIntersects: anInterval 
	"Return true if the receiver overlaps with anInterval."

	^(start between: anInterval first and: anInterval last) 
		or: [ anInterval first between: start and: stop ]! !


!OrderedCollection methodsFor: '*ma base additions' stamp: 'cm 1/7/2002 16:25'!
maAddAll: aSequenceableCollection afterIndex: integerIndex

	aSequenceableCollection reverseDo: [:each | self add: each afterIndex: integerIndex ].
	^aSequenceableCollection
! !

!OrderedCollection methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 20:33'!
maRemoveAll

	self setCollection: (Array new: self size)! !


!Set methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 22:01'!
maRemoveAll
	"Efficiently removes all elements from the receiver."

	self init: (self size max: 4)! !

!Set methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:41'!
maShallowCopy

	| copy |
	copy _ self species new: self size.
	self do: [ :each | copy add: each ].
	^copy! !


!Dictionary methodsFor: '*ma base additions'!
maAllKeysAtValue: anObject

	| aCollection |

	aCollection := OrderedCollection new.
	self keysAndValuesDo: [ :key :value | value = anObject ifTrue: [ aCollection add: key ] ].
	^aCollection! !

!Dictionary methodsFor: '*ma base additions'!
maAt: anObject ifPresent: oneArgBlock ifAbsent: zeroArgBlock

	| current uniqueObj |

	uniqueObj := 'x'.
	^(current := self
		at: anObject
		ifAbsent: [ uniqueObj ]) == uniqueObj
			ifTrue: [ zeroArgBlock value ]
			ifFalse: [ oneArgBlock value: current ]
! !

!Dictionary methodsFor: '*ma base additions' stamp: 'cmm 9/27/2003 19:40'!
maDeepCopy

	| answer |
	answer _ self species new.
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		answer at: eachKey copy put: eachValue copy ]! !

!Dictionary methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:45'!
maShallowCopy

	| copy |
	copy _ self species new.  "new: seems buggy w/ Dictionaries.."
	self keysAndValuesDo: 
		[ :eachKey :eachValue | copy at: eachKey put: eachValue ].
	^copy! !


!SharedQueue methodsFor: '*ma base additions' stamp: 'cmm 2/8/2005 23:34'!
notEmpty

	^ self isEmpty not! !


!String methodsFor: '*ma base additions'!
maAsIntegerFromRadix: anInteger
	"Answer a Smalltalk Integer with an equivalent value of the receiver
	represented in radix anInteger."

	^self
		inject: 0
		into: [ :sum :character | (sum * anInteger) + character digitValue ]
! !

!String methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 23:32'!
maBeginsWith: aString ignoringCase: aBoolean

	"Returns true if the receiver begins with the elements in aString,
	while ignoring the case if aBoolean is true."

	^aBoolean
		ifTrue:
			[ self asLowercase beginsWith: aString asLowercase ]
		ifFalse:
			[ self beginsWith: aString ]! !

!String methodsFor: '*ma base additions' stamp: 'cmm 1/23/2002 01:24'!
maEndsWith: aString ignoringCase: aBoolean

	"Returns true if the receiver begins with the elements in aString,
	while ignoring the case if aBoolean is true."

	^aBoolean
		ifTrue:
			[ self asLowercase endsWith: aString asLowercase ]
		ifFalse:
			[ self endsWith: aString ]! !

!String methodsFor: '*ma base additions' stamp: 'cmm 1/28/2003 11:57'!
maFormattedForPlural: aNumber
	"This is kind of a wing-nut method, but it can save you some
	redundant code if you care to make your programs user message
	plural and singular friendly.  It will add or remove an s based on
	aNumber and whether or not the receiver already ends in s."

	^aNumber > 0 & (aNumber <= 1)
		ifTrue:
			[ "should not end in s"
			(self
				maEndsWith: 's'
				ignoringCase: true)
					ifTrue:
						[ self
							copyFrom: 1
							to: self size - 1 ]
					ifFalse:
						[ self ] ]
		ifFalse:
			[ (self
				maEndsWith: 's'
				ignoringCase: true)
					ifTrue:
						[ "should end in s"
						self ]
					ifFalse:
						[ self , 's' ] ]! !

!String methodsFor: '*ma base additions' stamp: 'cmm 12/1/2004 23:02'!
maInstSize
	"Override from Object because this is many times faster."
	^ self size! !

!String methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:39'!
maPrintAbbreviatedOn: aStream

	self printOn: aStream
! !


!String class methodsFor: '*ma base additions' stamp: 'cmm 1/28/2003 15:51'!
maEmpty
	"Using a canonical empty String can reduce object-count in memory or a large Magma database."

	^''! !


!SystemNavigation methodsFor: '*ma base additions' stamp: 'cmm 1/2/2005 23:31'!
maAllMethodReferencesDo: aBlock
	"Value aBlock for every method in the system."
	Cursor execute showWhile:
		[ self
			allBehaviorsDo:
				[ : class |
				class selectorsDo:
					[ : sel | 
					aBlock value: (MethodReference class: class selector: sel) ] ] ]! !


!SystemNavigation class methodsFor: '*ma base additions' stamp: 'cmm 3/3/2004 22:57'!
maDefault: aSystemNavigation

	Default _ aSystemNavigation! !


!TimeProfileBrowser class methodsFor: '*ma base additions' stamp: 'cmm 12/24/2003 13:25'!
maOnBlock: block if: conditionBlock
	"Allows you to build up your sample set before invoking the profiler."
	^conditionBlock value 
		ifTrue: [ self onBlock: block ]
		ifFalse: [ block value ]! !


!WriteStream methodsFor: '*ma base additions' stamp: 'cmm 11/10/2002 20:35'!
endEntry
	"No-op for compatibility with TranscriptStream."! !

!WriteStream methodsFor: '*ma base additions'!
maPrint: anObject

	anObject isString ifTrue: [ self nextPutAll: anObject ] ifFalse: [ anObject printOn: self ]
! !

!WriteStream methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:03'!
maPrintAbbreviated: aMaObject

	aMaObject maPrintAbbreviatedOn: self
! !

!WriteStream methodsFor: '*ma base additions' stamp: 'cmm 8/23/2004 17:08'!
maPrintNumber: anInteger template: templateString

self maMarked: 'dev'.
"I hate this method...  Find a better solution and a better name because you only support Integers!!"
	templateString size - anInteger printString size timesRepeat: [ self nextPut: $0 ].
	anInteger maPrintAbbreviatedOn: self! !


!LimitedWriteStream methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:02'!
maPrintAbbreviated: aMaObject

	aMaObject maPrintAbbreviatedOn: self
! !

MaSystemNavigationOverrider initialize!
MaSingleton initialize!
