'From Squeak3.10alpha of 12 December 2006 [latest update: #7068] on 12 May 2007 at 3:57:32 pm'!
PluggableListMorph subclass: #MaPluggableListMorphOfMany
	instanceVariableNames: 'getSelectionListSelector setSelectionListSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tracing Messages Browser-widgets'!

!MaPluggableListMorphOfMany commentStamp: '<historical>' prior: 0!
I use this in the TracingMessagesBrowser because it's more usable for selecting ranges of methods.  There are a few minor enhancements, for example, you can drag the mouse as fast as you want and it won't miss any methods.!

MessageSet subclass: #TracingMessagesBrowser
	instanceVariableNames: 'autoSelectStrings messageSelections anchorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tracing Messages Browser'!
PackageInfo subclass: #TracingMessagesBrowserPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tracing Messages Browser-Info'!

!Object methodsFor: '*tracing messages browser' stamp: 'cmm 3/2/2004 21:27'!
maBrowseImplementorsOf: selector

	SystemNavigation new browseAllImplementorsOf: selector! !

!Object methodsFor: '*tracing messages browser' stamp: 'cmm 3/3/2004 23:58'!
maBrowseSendersOf: selectorSymbol

	SystemNavigation new browseAllCallsOn: selectorSymbol! !


!MaPluggableListMorphOfMany methodsFor: 'model access' stamp: 'cmm 1/18/2002 17:49'!
changeModelSelection: anInteger
	"Change the model's selected item index to be anInteger."

	^self
		changeModelSelection: anInteger
		shifted: Sensor shiftPressed
		controlled: Sensor controlKeyPressed
! !

!MaPluggableListMorphOfMany methodsFor: 'model access' stamp: 'cmm 1/18/2002 16:50'!
changeModelSelection: anInteger shifted: shiftedBoolean controlled: controlledBoolean
	"Change the model's selected item index to be anInteger."

	setIndexSelector ifNotNil:
		[ model 
			perform: setIndexSelector 
			with: anInteger
			with: shiftedBoolean
			with: controlledBoolean ]
! !

!MaPluggableListMorphOfMany methodsFor: 'model access' stamp: 'cmm 3/2/2004 23:06'!
itemSelectedAmongMultiple: index
	^model isMessageSelectedAt: index! !

!MaPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'cmm 3/2/2004 23:14'!
handlesMouseDown: evt
	^ true! !

!MaPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'cmm 3/2/2004 23:13'!
mouseDown: event
	| row |

	event yellowButtonPressed ifTrue: [^ self yellowButtonActivity: event shiftPressed].

	row := self rowAtLocation: event position.
	
	row = 0 ifTrue: [^super mouseDown: event].

	model okToChange ifFalse: [^ self].  "No change if model is locked"

	"Inform model of selected item and let it toggle."
	self
		changeModelSelection: row
		shifted: event shiftPressed
		controlled: event controlKeyPressed.


"
	event hand releaseMouseFocus: aMorph.
	submorphs do: [ :each | each changed ]
"! !

!MaPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'cmm 3/2/2004 18:16'!
mouseMove: event 
	"The mouse has moved, as characterized by the event provided.  Adjust the scrollbar, and alter the selection as appropriate"

	| oldIndex oldVal row |
	event position y < self top 
		ifTrue: 
			[scrollBar scrollUp: 1.
			row := self rowAtLocation: scroller topLeft + (1 @ 1)]
		ifFalse: 
			[row := event position y > self bottom 
				ifTrue: 
					[scrollBar scrollDown: 1.
					self rowAtLocation: scroller bottomLeft + (1 @ -1)]
				ifFalse: [ self rowAtLocation: event position]].
	row = 0 ifTrue: [^super mouseDown: event].

	model okToChange ifFalse: [^self].	"No change if model is locked"

	"Set meaning for subsequent dragging of selection"
	oldIndex := self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal := self listSelectionAt: oldIndex].
	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].

	"Inform model of selected item and let it toggle."
	self 
		changeModelSelection: row
		shifted: true
		controlled: event controlKeyPressed.
	self maMarked: 'performance'.	"this may be a performance issue, especially when dragging.."
	submorphs do: [:each | each changed]! !

!MaPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'cmm 1/18/2002 17:45'!
mouseUp: event
	"Not needed.  Overridden to do nothing."! !

!MaPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'cmm 1/18/2002 16:08'!
update: aSymbol 
	aSymbol == #allSelections ifTrue:
		[self selectionIndex: self getCurrentSelectionIndex.
		^ self changed].
	^ super update: aSymbol! !

!MaPluggableListMorphOfMany methodsFor: 'initialization' stamp: 'cmm 1/18/2002 16:08'!
list: listOfStrings
	scroller removeAllMorphs.
	list _ listOfStrings ifNil: [Array new].
	list isEmpty ifTrue: [^ self selectedMorph: nil].
	super list: listOfStrings.

	"At this point first morph is sensitized, and all morphs share same handler."
	scroller firstSubmorph on: #mouseEnterDragging
						send: #mouseEnterDragging:onItem:
						to: self.
	scroller firstSubmorph on: #mouseUp
						send: #mouseUp:onItem:
						to: self.
	"This should add this behavior to the shared event handler thus affecting all items"! !

!MaPluggableListMorphOfMany methodsFor: 'initialization' stamp: 'cmm 12/24/2002 15:47'!
on: anObject list: listSel primarySelection: getSelectionSel changePrimarySelection: setSelectionSel listSelection: getListSel changeListSelection: setListSel menu: getMenuSel keystroke: keyActionSel 
	"setup a whole load of pluggability options"

	getSelectionListSelector := getListSel.
	setSelectionListSelector := setListSel.
	self 
		on: anObject
		list: listSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: keyActionSel! !

!MaPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'cmm 1/18/2002 16:08'!
listSelectionAt: index
	getSelectionListSelector ifNil:[^false].
	^model perform: getSelectionListSelector with: index! !

!MaPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'cmm 1/18/2002 16:08'!
listSelectionAt: index put: value
	setSelectionListSelector ifNil:[^false].
	^model perform: setSelectionListSelector with: index with: value! !


!MaPluggableListMorphOfMany class methodsFor: 'instance creation' stamp: 'cmm 1/18/2002 16:08'!
on: anObject list: listSel primarySelection: getSelectionSel changePrimarySelection: setSelectionSel listSelection: getListSel changeListSelection: setListSel menu: getMenuSel
	^ self new
		on: anObject
		list: listSel
		primarySelection: getSelectionSel
		changePrimarySelection: setSelectionSel
		listSelection: getListSel
		changeListSelection: setListSel
		menu: getMenuSel
		keystroke: #arrowKey:from:		"default"! !

!MaPluggableListMorphOfMany class methodsFor: 'instance creation' stamp: 'cmm 1/18/2002 16:08'!
on: anObject list: listSel primarySelection: getSelectionSel changePrimarySelection: setSelectionSel listSelection: getListSel changeListSelection: setListSel menu: getMenuSel keystroke: keyActionSel 
	^ self new
		on: anObject
		list: listSel
		primarySelection: getSelectionSel
		changePrimarySelection: setSelectionSel
		listSelection: getListSel
		changeListSelection: setListSel
		menu: getMenuSel
		keystroke: keyActionSel! !


!ObjectExplorer methodsFor: '*tracing messages browser' stamp: 'cmm 1/22/2002 16:59'!
maCanDecipherSelectorPrefix

	^false
! !


!ParagraphEditor methodsFor: '*tracing messages browser' stamp: 'cmm 5/17/2005 23:05'!
implementorsOfIt
	"Open an implementors browser on the selected selector"

	| aSelector |
	self lineSelectAndEmptyCheck: [^ self].
	((aSelector _ self selectedSelector) isSymbol not
		and: [ self model notNil and: [ self model maCanDecipherSelectorPrefix not ] ]) ifTrue: [^ view flash].
	self terminateAndInitializeAround: [ self model maBrowseImplementorsOf: aSelector ]! !

!ParagraphEditor methodsFor: '*tracing messages browser' stamp: 'cmm 1/22/2002 16:53'!
selectedSelector
	"Try to make a selector out of the current text selection"

	^self selection string findSelector
		ifNil: [ self selection string ]
! !

!ParagraphEditor methodsFor: '*tracing messages browser' stamp: 'cmm 8/28/2003 14:49'!
sendersOfIt
	"Open a senders browser on the selected selector"

	| aSelector |
	self lineSelectAndEmptyCheck: [^ self].
	(aSelector _ self selectedSelector) == nil ifTrue: [^ view flash].
	self terminateAndInitializeAround:
		[ self model 
			ifNil: [ self systemNavigation browseAllCallsOn: aSelector ]
			ifNotNil: [ self model maBrowseSendersOf: aSelector ] ]! !


!PluggableTextMorph methodsFor: '*tracing messages browser' stamp: 'cmm 7/3/2003 14:06'!
update: aSymbol 
	aSymbol ifNil: [^self].
	aSymbol == #flash ifTrue: [^self flash].
	aSymbol == getTextSelector 
		ifTrue: 
			[self setText: self getText.
			^self setSelection: self getSelection].
	aSymbol == getSelectionSelector 
		ifTrue: [^self setSelection: self getSelection].
	(aSymbol == #autoSelect 
		and: [getSelectionSelector ~~ nil
		and: [ model notNil
		and: [ model autoSelectString notNil ] ] ]) ifTrue:
			[self handleEdit: 
					[ParagraphEditor abandonChangeText.	"no replacement!!"
					(textMorph editor)
						setSearch: model autoSelectString;
						againOrSame: true]].
	aSymbol == #clearUserEdits ifTrue: [^self hasUnacceptedEdits: false].
	aSymbol == #wantToChange 
		ifTrue: 
			[self canDiscardEdits ifFalse: [^self promptForCancel].
			^self].
	aSymbol == #appendEntry 
		ifTrue: 
			[self handleEdit: [self appendEntry].
			^self refreshWorld].
	aSymbol == #clearText 
		ifTrue: 
			[self handleEdit: [self changeText: Text new].
			^self refreshWorld].
	aSymbol == #bs 
		ifTrue: 
			[self handleEdit: [self bsText].
			^self refreshWorld].
	aSymbol == #codeChangedElsewhere 
		ifTrue: 
			[self hasEditingConflicts: true.
			^self changed]! !


!StringHolder methodsFor: '*tracing messages browser' stamp: 'cmm 1/22/2002 16:58'!
maCanDecipherSelectorPrefix

	^false
! !


!CodeHolder methodsFor: '*tracing messages browser' stamp: 'cmm 3/2/2004 23:07'!
messageListKey: aChar from: view
	"Respond to a Command key.  I am a model with a code pane, and I also
	have a listView that has a list of methods.  The view knows how to get
	the list and selection."

	| sel class |
	aChar == $D ifTrue: [^ self toggleDiffing].

	sel _ self selectedMessageName.
	aChar == $m ifTrue:  "These next two put up a type in if no message selected"
		[^ self useSelector: sel orGetSelectorAndSendQuery: #maBrowseImplementorsOf: to: self].
	aChar == $n ifTrue: 
		[^ self useSelector: sel orGetSelectorAndSendQuery: #maBrowseSendersOf: to: self].

	"The following require a class selection"
	(class _ self selectedClassOrMetaClass) ifNil: [^ self arrowKey: aChar from: view].
	aChar == $b ifTrue: [^ Browser fullOnClass: class selector: sel].
	aChar == $N ifTrue: [^ self browseClassRefs].
	aChar == $i ifTrue: [^ self methodHierarchy].
	aChar == $h ifTrue: [^ self classHierarchy].
	aChar == $p ifTrue: [^ self browseFullProtocol].

	"The following require a method selection"
	sel ifNotNil: 
		[aChar == $o ifTrue: [^ self fileOutMessage].
		aChar == $c ifTrue: [^ self copySelector].
		aChar == $v ifTrue: [^ self browseVersions].
		aChar == $O ifTrue: [^ self openSingleMessageBrowser].
		aChar == $x ifTrue: [^ self removeMessage].

		(aChar == $C and: [self canShowMultipleMessageCategories])
			ifTrue: [^ self showHomeCategory]].

	^ self arrowKey: aChar from: view! !


!ChangeList methodsFor: '*tracing messages browser' stamp: 'cmm 1/12/2002 00:34'!
browseCurrentVersionsOfSelections
	"Opens a message-list browser on the current in-memory versions of all methods that are currently seleted"
	|  aClass aChange aList |

	aList _ OrderedCollection new.
	Cursor read showWhile: [
		1 to: changeList size do: [:i |
			(listSelections at: i) ifTrue: [
				aChange _ changeList at: i.
				(aChange type = #method
					and: [(aClass _ aChange methodClass) notNil
					and: [aClass includesSelector: aChange methodSelector]])
						ifTrue: [
							aList add: (
								MethodReference new
									setStandardClass: aClass  
									methodSymbol: aChange methodSelector
							)
						]]]].

	aList size == 0 ifTrue: [^ self inform: 'no selected methods have in-memory counterparts'].
	MessageSet maPreferredMessageBrowser 
		openMessageList: aList 
		name: 'Current versions of selected methods in ', file localName! !


!ChangeSorter methodsFor: '*tracing messages browser' stamp: 'cmm 1/12/2002 00:35'!
browseMethodConflicts
	"Check to see if any other change set also holds changes to any methods in the selected change set; if so, open a browser on all such."

	| aList |

	aList _ myChangeSet 
		messageListForChangesWhich: [ :aClass :aSelector |
			(ChangeSorter allChangeSetsWithClass: aClass selector: aSelector) size > 1
		]
		ifNone: [^ self inform: 'No other change set has changes
for any method in this change set.'].
	
	MessageSet maPreferredMessageBrowser 
		openMessageList: aList 
		name: 'Methods in "', myChangeSet name, '" that are also in other change sets (', aList size printString, ')'
	! !

!ChangeSorter methodsFor: '*tracing messages browser' stamp: 'cmm 1/12/2002 00:35'!
methodConflictsWithOtherSide
	"Check to see if the change set on the other side shares any methods with the selected change set; if so, open a browser on all such."

	| aList other |

	self checkThatSidesDiffer: [^ self].
	other _ (parent other: self) changeSet.
	aList _ myChangeSet 
		messageListForChangesWhich: [ :aClass :aSelector |
			aClass notNil and: [(other methodChangesAtClass: aClass name) includesKey: aSelector]
		]
		ifNone:  [^ self inform: 'There are no methods that appear
both in this change set and
in the one on the other side.'].
	
	MessageSet maPreferredMessageBrowser 
		openMessageList: aList 
		name: 'Methods in "', myChangeSet name, '" that are also in ', other name,' (', aList size printString, ')'
	! !


!MessageSet methodsFor: '*tracing messages browser' stamp: 'cm 1/8/2002 13:41'!
browseMessages
	"Present a menu of all messages sent by the currently selected message. 
	Open a message set browser of all implementors of the message chosen.
	Do nothing if no message is chosen."

	self selectMessageAndEvaluate: [ :selector | self maBrowseImplementorsOf: selector ]
! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cm 1/8/2002 13:41'!
browseSendersOfMessages
	"Present a menu of the currently selected message, as well as all
	messages sent by it.  Open a message set browser of all implementors
	of the message chosen."

	self selectMessageAndEvaluate: [ :selector | self maBrowseSendersOf: selector ]
! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 1/17/2002 16:15'!
deleteFromMessageList: aMessage
	"Delete the given message from the receiver's message list"

	messageList remove: aMessage.
	self changed: #messageList.
	self messageListIndex: (self messageListIndex min: messageList size)
! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 3/3/2004 00:18'!
initializeMessageList: anArray
	| s |

	messageList _ OrderedCollection new.
	anArray do: [ :each |
		MessageSet 
			parse: each  
			toClassAndSelector: [ :class :sel |
				class ifNotNil: [
					s _ self
						maPreferredSignatureFor: class
						selector: sel.
					messageList add: (
						MethodReference new
							setClass: class  
							methodSymbol: sel 
							stringVersion: s
					)
				]
			]
	].
	messageListIndex _ (1 min: messageList size).
	contents _ ''! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 1/12/2002 14:22'!
maPreferredSignatureFor: aClass selector: aSymbol

	^String streamContents:
		[ :stream |
		self 
			maPrintPreferredSignatureOn: stream
			class: aClass
			selector: aSymbol ]
! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 1/11/2002 23:38'!
maPrintPreferredSignatureOn: aWriteStream 	class: aClass selector: aSymbol

	aWriteStream
		nextPutAll: aClass name;
		space;
		nextPutAll: aSymbol;
		nextPutAll: ' {';
		nextPutAll: ((aClass organization categoryOfElement: aSymbol) ifNil: ['']);
		nextPut: $}
! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 1/18/2002 13:35'!
maToggleIfShiftPressed: aBoolean

	^Sensor shiftPressed
		ifTrue: [ aBoolean not ]
		ifFalse: [ aBoolean ]
! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 3/1/2004 00:02'!
messageListIndex: anInteger 
	"Set the index of the selected item to be anInteger."

	messageListIndex _ anInteger.
	contents _ 
		messageListIndex ~= 0
			ifTrue: [self selectedMessage]
			ifFalse: [''].
	self changed: #messageListIndex.	 "update my selection"
	self editSelection: #editMessage.
	self contentsChanged.
	(messageListIndex ~= 0 
		and: [ autoSelectString notNil
		and: [ self contents notEmpty ] ])
			ifTrue: [self changed: #autoSelect].
	self decorateButtons
! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 1/12/2002 14:28'!
openAsMorphNamed: labelString inWorld: aWorld
	"Open the receiver in a morphic window in the given world"

	(self inMorphicWindowLabeled: labelString) openInWorld: aWorld.
	self changed: #autoSelect
! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 1/27/2003 22:24'!
reformulateList
	"Changed to quit losing our position in the darn list as we trace messages"

	super reformulateList! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 1/16/2002 13:53'!
removeMessageFromBrowser
	"Remove the selected message from the browser."

	messageListIndex = 0 ifTrue: [^ self].
	self deleteFromMessageList: self selection.
	self adjustWindowTitleAfterFiltering
! !

!MessageSet methodsFor: '*tracing messages browser' stamp: 'cmm 3/3/2004 23:30'!
setFilteredList: newList
	"Establish newList as the new list if appropriate, and adjust the window title accordingly; if the new list is of the same size as the old, warn and do nothing"

	newList size == 0
		ifTrue:
			[^ self inform: 'Nothing would be left in the list if you did that'].
	newList size == messageList size
		ifTrue:
			[^ self inform: 'That leaves the list unchanged'].
	self initializeMessageList: newList.
	self adjustWindowTitleAfterFiltering! !


!MessageSet class methodsFor: '*tracing messages browser' stamp: 'cmm 1/13/2002 15:24'!
maPreferredMessageBrowser

	^Preferences traceMessages
		ifTrue: [ TracingMessagesBrowser ]
		ifFalse: [ self ]
! !


!SystemNavigation methodsFor: '*tracing messages browser' stamp: 'cmm 7/3/2003 12:44'!
browseMessageList: messageList name: labelString autoSelect: autoSelectString
	| title aSize |
	"Create and schedule a MessageSet browser on the message list."

	messageList size = 0 ifTrue: 
		[^ (PopUpMenu labels: ' OK ')
				startUpWithCaption: 'There are no
' , labelString].

	title _ (aSize _ messageList size) > 1
		ifFalse:	[labelString]
		ifTrue:	[ labelString, ' [', aSize printString, ']'].

	MessageSet maPreferredMessageBrowser
		openMessageList: messageList 
		name: title 
		autoSelect: autoSelectString! !


!TracingMessagesBrowser methodsFor: 'building' stamp: 'cmm 2/23/2002 15:45'!
addChildMessages: methodReferences autoSelectString: aString

	| currentIndentionLevel addables |

	autoSelectStrings 
		at: messageListIndex 
		put: aString keywords first.
	currentIndentionLevel _ self indentionsIn: self selection stringVersion.
	addables _ methodReferences reject: [ :each | messageList includes: each ].
	addables do: [ :each | each stringVersion: ((self indentionPrefixOfSize: currentIndentionLevel + 1), each stringVersion) ].
	messageList
		maAddAll: addables
		afterIndex: self messageListIndex.
	autoSelectStrings
		maAddAll: (addables collect: [ :each | nil ])
		afterIndex: self messageListIndex.
	messageSelections
		maAddAll: (Array new: addables size withAll: false)
		afterIndex: self messageListIndex.
	self changed: #messageList.
	"If only one possibility, go to it."
	self messageListIndex: (methodReferences size = 1
		ifTrue: 
			[ self deselectAll.
			messageList indexOf: methodReferences first ]
		ifFalse: [ messageListIndex ])
! !

!TracingMessagesBrowser methodsFor: 'building' stamp: 'cmm 2/22/2002 01:22'!
addChildMethodsNamed: selectorSymbol

	| methodsReferences |

	messageListIndex = 0 
		ifTrue:
			[ ^(PopUpMenu labels: ' OK ')
				startUpWithCaption: 'Please reselect a method.' ].
	(methodsReferences _ self filteredSelectorsNamed: selectorSymbol) isEmpty
		ifTrue:
			[ ^(PopUpMenu labels: ' OK ')
				startUpWithCaption: 'There are no methods named ', selectorSymbol ]
		ifFalse:
			[ self
				addChildMessages: methodsReferences
				autoSelectString: selectorSymbol ]
! !

!TracingMessagesBrowser methodsFor: 'building' stamp: 'cmm 1/22/2002 13:59'!
addParentMessages: methodReferences autoSelectString: aString

	| currentIndentionLevel addables |

	addables _ methodReferences reject: [ :each | messageList includes: each ].
	currentIndentionLevel _ self indentionsIn: self selection stringVersion.
	(currentIndentionLevel = 0 and: [ addables notEmpty ])
		ifTrue: 
			[ self indentEverything.
			currentIndentionLevel _ 1 ].
	addables do: [ :each | each stringVersion: ((self indentionPrefixOfSize: currentIndentionLevel - 1), each stringVersion) ].
	messageList
		maAddAll: addables
		afterIndex: self messageListIndex - 1.
	autoSelectStrings
		maAddAll: (addables collect: [ :each | aString ])
		afterIndex: self messageListIndex - 1.
	messageSelections
		maAddAll: (Array new: addables size withAll: false)
		afterIndex: self messageListIndex - 1.
	self changed: #messageList.
	"If only one possibility, go to it."
	self messageListIndex: (methodReferences size = 1
		ifTrue:
			[ self deselectAll.
			messageList indexOf: methodReferences first ]
		ifFalse:
			[ "otherwise, stay where we are.."
			self messageListIndex + addables size ])
! !

!TracingMessagesBrowser methodsFor: 'building' stamp: 'cm 1/9/2002 19:04'!
addParentMethodsSending: selectorSymbol

	| methodsList |
	(methodsList _ self filteredSelectorsSending: selectorSymbol) isEmpty
		ifTrue:
			[ ^(PopUpMenu labels: ' OK ')
				startUpWithCaption: 'There are no methods that send ', selectorSymbol ]
		ifFalse:
			[ self
				addParentMessages: methodsList
				autoSelectString: selectorSymbol keywords first ]
! !

!TracingMessagesBrowser methodsFor: 'building' stamp: 'cm 1/9/2002 14:27'!
autoSelectString: aString

	super autoSelectString: aString.
	autoSelectStrings _ messageList collect: [ :each | aString ]
! !

!TracingMessagesBrowser methodsFor: 'building' stamp: 'cmm 1/30/2002 00:53'!
deleteFromMessageList: aMethodReference
	"Delete the given message from the receiver's message list"

	| index |
	autoSelectStrings removeAt: (index _ messageList indexOf: aMethodReference).
	messageSelections removeAt: index.
	super deleteFromMessageList: aMethodReference.
	anchorIndex ifNotNil:
		[ anchorIndex _ anchorIndex min: messageList size ]
! !

!TracingMessagesBrowser methodsFor: 'building' stamp: 'cmm 4/3/2002 00:03'!
removeMessageFromBrowser

	| indexToSelect |
	indexToSelect _ (messageSelections indexOf: true) max: 1.
	self selectedMessages do: [ :eachMethodReference | self deleteFromMessageList: eachMethodReference ].
	self deselectAll.
	messageSelections 
		at: (indexToSelect min: messageSelections size)  "safety"
		put: true.
	anchorIndex _ indexToSelect
! !

!TracingMessagesBrowser methodsFor: 'accessing' stamp: 'cmm 12/19/2002 23:13'!
annotation

	^self numberOfSelectedMessages > 1
		ifTrue: [ String maEmpty ]
		ifFalse: [ super annotation ]
! !

!TracingMessagesBrowser methodsFor: 'accessing' stamp: 'cmm 12/19/2002 23:13'!
contents

	^self numberOfSelectedMessages > 1
		ifTrue: [ String maEmpty ]
		ifFalse: [ super contents ]
! !

!TracingMessagesBrowser methodsFor: 'message list menu' stamp: 'cmm 1/11/2002 23:26'!
browseMessages
	"Present a menu of all messages sent by the currently selected message. 
	Open a message set browser of all implementors of the message chosen.
	Do nothing if no message is chosen."

	self selectMessageAndEvaluate: [ :selector | self maBrowseImplementorsOf: selector ]
! !

!TracingMessagesBrowser methodsFor: 'message list menu' stamp: 'cmm 12/18/2003 23:05'!
browseSendersOfMessages
	"Present a menu of the currently selected message, as well as all
	messages sent by it.  Open a message set browser of all implementors
	of the message chosen."

	self selectMessageAndEvaluate: [ :selector | self maBrowseSendersOf: selector ]
! !

!TracingMessagesBrowser methodsFor: 'private initializing' stamp: 'cmm 1/18/2002 17:13'!
buildMorphicMessageList
	"Build my message-list object in morphic"

	| aListMorph |
	aListMorph _ MaPluggableListMorphOfMany new.
	aListMorph
		setProperty: #highlightSelector toValue: #highlightMessageList:with:;
		setProperty: #itemConversionMethod toValue: #asStringOrText;
		setProperty: #balloonTextSelectorForSubMorphs toValue: #balloonTextForClassAndMethodString.
	aListMorph
		on: self
		list: #messageList
		primarySelection: #messageListIndex
		changePrimarySelection: #toggleSelectionAt:shifted:controlled:
		listSelection: #isMessageSelectedAt:
		changeListSelection: #messageAt:beSelected:
		menu: #messageListMenu:shifted:
		keystroke: #messageListKey:from:.
	aListMorph enableDragNDrop: Preferences browseWithDragNDrop.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	^ aListMorph
! !

!TracingMessagesBrowser methodsFor: 'private initializing' stamp: 'cmm 1/17/2002 22:33'!
initialize

	super initialize.
	messageSelections _ OrderedCollection new.
	autoSelectStrings _ OrderedCollection new
! !

!TracingMessagesBrowser methodsFor: 'private initializing' stamp: 'cmm 1/18/2002 00:41'!
initializeMessageList: anArray

	messageSelections _ (Array new: anArray size withAll: false) asOrderedCollection.
	super initializeMessageList: anArray.
	"autoSelectStrings is initialized right after this method, in autoSelectString:"
! !

!TracingMessagesBrowser methodsFor: 'actions' stamp: 'cmm 1/18/2002 13:46'!
deselectAll

	1 to: messageSelections size do: [ :index | messageSelections at: index put: false ]
! !

!TracingMessagesBrowser methodsFor: 'actions' stamp: 'cmm 1/22/2002 17:46'!
maBrowseImplementorsOf: selectorSymbol

	| selectorToBrowse |
	selectorToBrowse _ self selection 
		ifNil: [ selectorSymbol ] 
		ifNotNil: [ self getImplementorNamed: selectorSymbol ].
	(self hasUnacceptedEdits or: [ (self maToggleIfShiftPressed: Preferences traceMessages) not ])
		ifTrue: [ super maBrowseImplementorsOf: selectorToBrowse ]
		ifFalse: [ self addChildMethodsNamed: selectorToBrowse ]
! !

!TracingMessagesBrowser methodsFor: 'actions' stamp: 'cmm 1/22/2002 15:32'!
maBrowseSendersOf: selectorSymbol

	(self hasUnacceptedEdits or: [ (self maToggleIfShiftPressed: Preferences traceMessages) not ])
		ifTrue: [ super maBrowseSendersOf: selectorSymbol ]
		ifFalse: [ self addParentMethodsSending: selectorSymbol ]
! !

!TracingMessagesBrowser methodsFor: 'actions' stamp: 'cmm 1/18/2002 16:32'!
messageAt: indexInteger beSelected: aBoolean

	^messageSelections
		at: indexInteger
		put: aBoolean
! !

!TracingMessagesBrowser methodsFor: 'actions' stamp: 'cmm 7/3/2003 14:01'!
messageListIndex: anInteger

	autoSelectStrings notEmpty ifTrue: 
		[ autoSelectString _ 
			anInteger = 0
				ifTrue: [ '' ]
				ifFalse:
					[ messageListIndex _ anInteger.  "setting the window label, below, can't wait for this.."
					self containingWindow setLabel: (self windowLabelAt: anInteger).
					autoSelectStrings at: anInteger ] ].
	anInteger > 0 ifTrue:
		[ self
			messageAt: anInteger
			beSelected: true ].
	super messageListIndex: anInteger
! !

!TracingMessagesBrowser methodsFor: 'actions' stamp: 'cmm 1/18/2002 13:01'!
messageListKey: aChar from: view

	aChar = $f ifTrue: [ ^self removeMessageFromBrowser ].
	^super
		messageListKey: aChar
		from: view
! !

!TracingMessagesBrowser methodsFor: 'actions' stamp: 'cmm 2/10/2002 22:43'!
removeMessage
	"Remove the selected messages from the system."

	self selectedMessages size = 0 ifTrue: [ ^self ].
	self selectedMessages size = 1 ifTrue: [ ^super removeMessage ].
	(self confirm: 'Are you certain you want to remove all of the selected methods from the image?') ifFalse: [ ^self ].
	self selectedMessages do:
		[ :each | 
		each actualClass removeSelector: each methodSymbol.
		self deleteFromMessageList: self selection ]
! !

!TracingMessagesBrowser methodsFor: 'actions' stamp: 'cmm 1/22/2002 23:30'!
toggleSelectionAt: currentPosition shifted: isShifted controlled: isControlled

	currentPosition = 0 ifTrue: [ ^nil ].
	isControlled
		ifTrue: 
			[ isShifted
				ifTrue:
					[ self selectAllBetweenAnchorAnd: currentPosition ]
				ifFalse:
					[ self toggleMessageSelectionAt: currentPosition.
					anchorIndex _ currentPosition ] ]
		ifFalse: 
			[ self deselectAll.
			isShifted
				ifTrue:
					[ self selectAllBetweenAnchorAnd: currentPosition ]
				ifFalse:
					[ self 
						messageAt: currentPosition
						beSelected: true.
					anchorIndex _ currentPosition ] ].
	self messageListIndex: currentPosition
! !

!TracingMessagesBrowser methodsFor: 'private actions' stamp: 'cmm 1/18/2002 15:17'!
deselectAllBetweenLastSelectionAnd: indexPosition

	| lower higher |
	lower _ messageListIndex min: indexPosition.
	higher _ messageListIndex max: indexPosition.
	lower = 0 ifTrue: [ ^nil ].
	lower to: higher do:
		[ :index | messageSelections at: index put: false ]
! !

!TracingMessagesBrowser methodsFor: 'private actions' stamp: 'cmm 1/22/2002 16:04'!
selectAllBetweenAnchorAnd: indexPosition

	| lower higher |
	self deselectAllBetweenLastSelectionAnd: indexPosition.
	anchorIndex ifNil: [ anchorIndex _ indexPosition ].
	lower _ anchorIndex min: indexPosition.
	higher _ anchorIndex max: indexPosition.
	lower to: higher do:
		[ :index | messageSelections at: index put: true ]
! !

!TracingMessagesBrowser methodsFor: 'private actions' stamp: 'cmm 1/18/2002 11:28'!
selectedMessages

	| answer |
	answer _ OrderedCollection new.
	messageSelections withIndexDo:
		[ :eachSelection :index |
		eachSelection ifTrue: [ answer add: (messageList at: index) ] ].
	^answer
! !

!TracingMessagesBrowser methodsFor: 'private actions' stamp: 'cmm 1/18/2002 11:19'!
selectedMessagesDo: oneArgBlock

	messageSelections copy withIndexDo:
		[ :eachSelection :index |
		eachSelection ifTrue: [ oneArgBlock value: (messageList at: index) ] ]
! !

!TracingMessagesBrowser methodsFor: 'private actions' stamp: 'cmm 1/18/2002 15:19'!
toggleMessageSelectionAt: anInteger

	messageSelections 
		at: anInteger 
		put: (messageSelections at: anInteger) not
! !

!TracingMessagesBrowser methodsFor: 'filtering' stamp: 'cmm 1/17/2002 22:24'!
filterFrom: aBlock
	"Filter the receiver's list down to only those items that satisfy aBlock, which takes a class an a selector as its arguments."

	| newList newAutoSelectStrings newMessageSelections |
	newList _ messageList class new.
	newAutoSelectStrings _ autoSelectStrings class new.
	newMessageSelections _ messageSelections class new.
	messageList withIndexDo:
		[ :each :index |
		(self class parse: each toClassAndSelector: aBlock)
			ifTrue:
				[ newList add: each.
				newAutoSelectStrings add: (autoSelectStrings at: index).
				newMessageSelections add: (messageSelections at: index) ] ].
	autoSelectStrings _ newAutoSelectStrings.
	self setFilteredList: newList.
! !

!TracingMessagesBrowser methodsFor: 'filtering' stamp: 'cmm 7/3/2003 12:33'!
filteredSelectorsNamed: selectorSymbol

	^SystemNavigation new allImplementorsOf: selectorSymbol
! !

!TracingMessagesBrowser methodsFor: 'filtering' stamp: 'cmm 7/3/2003 12:24'!
filteredSelectorsSending: selectorSymbol
	
	^SystemNavigation new allCallsOn: selectorSymbol from: ProtoObject
! !

!TracingMessagesBrowser methodsFor: 'private accessing' stamp: 'cmm 2/7/2002 23:41'!
getImplementorNamed: selectorSymbol

	 | allPossibilities |
	allPossibilities _ (((self selection maActualMethod messages 
		select: [ :eachSelector | eachSelector beginsWith: selectorSymbol ])
		copyWith: selectorSymbol)
		select: [ :each | Symbol hasInterned: each ifTrue: [ :s | ] ])
		asSet; asSortedCollection; asOrderedCollection.
	(allPossibilities includes: selectorSymbol) ifTrue:
		[ allPossibilities addFirst: (allPossibilities remove: selectorSymbol) ].
	^allPossibilities size > 1
		ifTrue: 
			[ | selectionIndex |
			selectionIndex _ (PopUpMenu labelArray: allPossibilities lines: #(1))
				startUpWithCaption: 
					'Browse implementors of
					which message?'.
			selectionIndex = 0 ifTrue: [ selectorSymbol ] ifFalse: [ allPossibilities at: selectionIndex ] ]
		ifFalse: [ allPossibilities isEmpty
			ifTrue: [ selectorSymbol ]
			ifFalse: [ allPossibilities first ] ]
! !

!TracingMessagesBrowser methodsFor: 'private accessing' stamp: 'cmm 1/18/2002 12:27'!
numberOfSelectedMessages

	^messageSelections occurrencesOf: true
! !

!TracingMessagesBrowser methodsFor: 'private accessing' stamp: 'cm 1/9/2002 17:26'!
windowLabelAt: anInteger

	| str |
	^(str _ autoSelectStrings at: anInteger)
		ifNil:
			[ 'Implementors of ',
				(self class
					parse: self selection
					toClassAndSelector: [ :class :selector | selector ]) ]
		ifNotNil:
			[ 'Senders of ', str ]
! !

!TracingMessagesBrowser methodsFor: 'indenting' stamp: 'cmm 1/13/2002 00:02'!
indentEverything

	messageList do: [ :each | each stringVersion: (self indentionPrefixOfSize: 1), each stringVersion ]
! !

!TracingMessagesBrowser methodsFor: 'indenting' stamp: 'cm 1/8/2002 17:50'!
indentionPrefixOfSize: levelInteger

	| answer |
	answer _ String new: levelInteger * self indentionSize.
	answer atAllPut: $ . "space"
	^answer
! !

!TracingMessagesBrowser methodsFor: 'indenting' stamp: 'cm 1/8/2002 17:34'!
indentionSize

	^2  "that is, 2 spaces.."
! !

!TracingMessagesBrowser methodsFor: 'indenting' stamp: 'cm 1/8/2002 17:50'!
indentionsIn: aString

	aString
		withIndexDo: 
			[ :eachChar :index | 
			eachChar = $  "space" ifFalse: [ ^(index-1) / self indentionSize ] ].
	^0
! !

!TracingMessagesBrowser methodsFor: 'testing' stamp: 'cmm 3/2/2004 23:40'!
isMessageSelectedAt: anInteger

	^messageSelections at: anInteger ifAbsent: [ false ]! !

!TracingMessagesBrowser methodsFor: 'private testing' stamp: 'cmm 1/22/2002 16:58'!
maCanDecipherSelectorPrefix

	^true
! !


!TracingMessagesBrowser class methodsFor: 'initializing' stamp: 'cmm 1/28/2003 22:20'!
initialize

	self setUpPreferencesPanel! !

!TracingMessagesBrowser class methodsFor: 'initializing' stamp: 'cmm 1/13/2002 15:30'!
setUpPreferencesPanel
	"This is normally called by the post script for my change set."

	Preferences
		addPreference: #traceMessages
		category: #browsing
		default: true
		balloonHelp: 'If true, browsing senders or implementors in a methods browser will add to the methods in that browser instead of opening a new browser.'
! !


!TracingMessagesBrowserPackageInfo methodsFor: 'accessing' stamp: 'cmm 3/31/2004 12:14'!
prerequisitePackages
	^ #( 'Ma base additions' )! !

!TracingMessagesBrowserPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 4/1/2004 23:35'!
readmeText
	^'A new preference has been added under the "Browse" category called "traceMessages".  When selected, MessageList browser profileration is reduced by indenting implementors below and outdenting senders above in the same browser, rather than opening a new browser each time.  Additionally, you can very easily pare the list by multi-selecting (by click+drag or shift+click a range) and pressing command+f (for remove From browser).

I would like to acknowledge someone at Applied Reasoning (I don''t know who), who originally thought of this idea and implemented it in VisualWorks and VisualAge.
'! !

TracingMessagesBrowser initialize!
